#ifndef __SCSI_H__
#define __SCSI_H__

#ifndef NULL
#define NULL                    ((void *)0)
#endif
//CBWCSW־
#define CBW_SIGNATURE           0x55534243
#define CSW_SIGNATURE           0x55534253
//CSWbCSWStatusλִ״̬־
#define SCSI_PASSED 		    0		//ͨ
#define SCSI_FAILED 		    1		//ʧ
#define SCSI_PHASE_ERROR 	    2		//״̬

#define SCSI_TESTUNITREADY      0x00
#define SCCI_STARTSTOPUNIT      0x1b
#define SCSI_REQUESTSENSE       0x03
#define SCSI_INQUIRY            0x12
#define SCSI_MODESENSE6         0x1a
#define SCSI_MODESENSE10        0x5a
#define SCSI_MEDIAREMOVAL       0x1e
#define SCSI_FORMATCAPACITY     0x23
#define SCSI_READCAPACITY10     0x25
#define SCSI_READ10             0x28
#define SCSI_WRITE10            0x2a
#define SCSI_VERIFY10           0x2f

#define SENSE_NOSENSE           0x00
#define SENSE_RECOVEREDERROR    0x01
#define SENSE_NOTREADY          0x02
#define SENSE_MEDIUMERROR       0x03
#define SENSE_HARDWAREERROR     0x04
#define SENSE_ILLEGALREQUEST    0x05
#define SENSE_UNITATTENTION     0x06
#define SENSE_DATAPROTECT       0x07
#define SENSE_BLANKCHECK        0x08
#define SENSE_VENDORSPECIFIC    0x09
#define SENSE_COPYABORTED       0x0a
#define SENSE_ABORTE_COMMAND    0x0b
#define SENSE_VOLUMEOVERFLOW    0x0d
#define SENSE_MISCOMPARE        0x0e

#define ASC_INVALIDCOMMAND      0x20
#define ASC_MEDIUMNOTPRESENT    0x3a

typedef struct		//ṹ嶨һΪ CBW ݽṹ USB Mass Storage ClassMSC豸е鴫䣨Command Block WrapperCBW
{ 
    DWORD   dCBWSignature; 		//CBW ǩڱʶ CBW ĿʼͨΪ̶ֵ 0x43425355
    DWORD   dCBWTag; 			//CBW ıǩΨһʶ CBW MSC 豸У豸ʹñǩƥ飨CBW״̬ݣCSW
    DWORD   dCBWDataLength; 	//CBW ݴ׶ݳȡĳЩݳȿΪ0		Ҫִ CBW ڼ䣬˵㴫ֶָֽǸ CBW ֮ݰĳȡ
    BYTE    bmCBWFlags; 		//CBW ı־λָʾݴķ
    BYTE    bCBWLUN; 			//߼ԪţLogical Unit NumberLUNָҪִ߼Ԫ
    BYTE    bCBWCBLength; 		//CBW ĳȣʾ CBW bScsiOpcode  ScsiParamֽ
    BYTE    bScsiOpcode;		//SCSI 룬ָҪִеľ SCSI 
    BYTE    ScsiParam[15]; 		//SCSI Ĳ԰15ֽڵĲݡ
}CBW; 							//CBW-Command Block Wrapper		豸CBW
 
typedef struct
{
	DWORD   dCSWSignature; 
	DWORD   dCSWTag; 
	DWORD   dCSWDataResidue; 
	BYTE    bCSWStatus; 
}CSW; 							//CSW-Command Status Wrapperִ״̬		豸CSW

void scsi_process();

void scsi_in(BYTE *pData, int nSize);
void scsi_out(BYTE *pData, int nSize);

BOOL scsi_test_unit_ready();
void scsi_start_stop_unit();
void scsi_media_removal();
void scsi_inquiry();
void scsi_read_capacity10();
void scsi_format_capacity();
void scsi_request_sense();
void scsi_mode_sense6();
void scsi_mode_sense10();
void scsi_read10();
void scsi_write10();
void scsi_verify10();

#endif
